## calligraplan 3.2.2

=== CMakeLists.txt ===

project(calligraplan)

cmake_minimum_required(VERSION 3.0)
if (POLICY CMP0002)
    cmake_policy(SET CMP0002 NEW)
endif ()
if (POLICY CMP0017)
    cmake_policy(SET CMP0017 NEW)
endif ()
if (POLICY CMP0022)
    cmake_policy(SET CMP0022 NEW)
endif ()
if (POLICY CMP0026)
    cmake_policy(SET CMP0026 NEW)
endif()
if (POLICY CMP0046)
    cmake_policy(SET CMP0046 NEW)
endif ()
if (POLICY CMP0059)
    cmake_policy(SET CMP0059 NEW)
endif()
if (POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if (POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

list(APPEND CMAKE_AUTOMOC_MACRO_NAMES "PLAN_SCHEDULERPLUGIN_EXPORT")

# define the version of Plan
# update these version for every release:
set(PLAN_YEAR 2019) # update every year
set(PLAN_VERSION_STRING "3.2.2")
set(PLAN_STABLE_VERSION_MAJOR 3) # 3 for 3.x, 4 for 4.x, etc.
set(PLAN_STABLE_VERSION_MINOR 2) # 0 for 3.0, 1 for 3.1, etc.
set(PLAN_VERSION_RELEASE 2)     # 89 for Alpha, increase for next test releases, set 0 for first Stable, etc.
#set(PLAN_ALPHA 1) # uncomment only for Alpha
#set(PLAN_BETA 1) # uncomment only for Beta
#set(PLAN_RC 1) # uncomment only for RC

# Define the generic version of the Calligra Plan libraries here
# This makes it easy to advance it when the next release comes.
# 14 was the last GENERIC_CALLIGRA_LIB_VERSION_MAJOR of the previous Calligra series
# (2.x) so we're starting with 15 in 3.x series.
if(PLAN_STABLE_VERSION_MAJOR EQUAL 3)
    math(EXPR GENERIC_PLAN_LIB_VERSION_MAJOR "${PLAN_STABLE_VERSION_MINOR} + 15")
else()
    # let's make sure we won't forget to update the "15"
    message(FATAL_ERROR "Reminder: please update offset == 15 used to compute GENERIC_PLAN_LIB_VERSION_MAJOR to something bigger")
endif()
set(GENERIC_PLAN_LIB_VERSION "${GENERIC_PLAN_LIB_VERSION_MAJOR}.0.0")
set(GENERIC_PLAN_LIB_SOVERSION "${GENERIC_PLAN_LIB_VERSION_MAJOR}")

message(STATUS "")
message(STATUS "Build Calligra Plan ${PLAN_VERSION_STRING} with cmake version: ${CMAKE_VERSION}, required version: ${CMAKE_MINIMUM_REQUIRED_VERSION}")
message(STATUS "")


# ensure out-of-source build
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" isBuildInSource)
if(isBuildInSource)
    message(FATAL_ERROR "Compiling Plan inside the source folder is not possible.\nPlease refer to the build instruction: https://community.kde.org/Calligra/Building/3\nYou need to clean up the source folder from all build artifacts just created, otherwise further building attempts will fail again: With a git repo, you can use \"git clean -df\" in the toplevel source folder (attention! will remove also uncommited changes to the source code). With sources from a file bundle (like a zip file), delete the source folder and unbundle the sources again.")
endif()


############
#############
## Options ##
#############
############

option(PACKAGERS_BUILD "Build support of multiple CPU architectures in one binary. Should be used by packagers only." ON)

##########################
###########################
## Look for ECM, Qt, KF5 ##
###########################
##########################

find_package(ECM 5.19 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

# ECM KDE macros (include first, to have their policies and settings effect all other macros)
include(KDEInstallDirs)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
# CMake macros
include(CMakePackageConfigHelpers)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckIncludeFile)
include(GenerateExportHeader)
include(FeatureSummary)
# ECM macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
# Own macros
# This macro is a copy from calligra so only needs to be included when plan is build stand alone
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
include(MacroOptionalFindPackage)

set(REQUIRED_KF5_VERSION "5.45.0")

find_package(KF5 ${REQUIRED_KF5_VERSION} REQUIRED
    COMPONENTS
        Init
        Archive
#             Codecs
#             Completion
        Config
        ConfigWidgets
        CoreAddons
        DBusAddons
#             DocTools
        GuiAddons
        I18n
        IconThemes
        ItemViews
        JobWidgets
        KIO
        Notifications
#             NotifyConfig
        Parts
#             Sonnet
        TextWidgets
        WidgetsAddons
        WindowSystem
        XmlGui
#         Kross
)

find_package(KF5Activities)

set_package_properties(KF5Activities PROPERTIES
    DESCRIPTION "Library for Activities"
    PURPOSE "Required for activities support (optional)"
    TYPE OPTIONAL
)
if(KF5Activities_FOUND)
    set(HAVE_KACTIVITIES TRUE)
endif()

find_package(KF5KHtml)
set_package_properties(KF5KHtml PROPERTIES
    PURPOSE "Required for rich text support"
    TYPE REQUIRED
)

find_package(KF5Holidays)
set_package_properties(KF5Holidays PROPERTIES
    DESCRIPTION "Library for generation of public holidays"
    PURPOSE "Required for holidays support (optional)"
    TYPE RECOMMENDED
)


set(REQUIRED_QT_VERSION "5.9.0")

find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED
    COMPONENTS
        Core
        Gui
        PrintSupport
        Test
        Widgets
        Xml
)
find_package(Qt5DBus ${REQUIRED_QT_VERSION} QUIET)
set_package_properties(Qt5DBus PROPERTIES
    DESCRIPTION "Library for dbus access"
    PURPOSE "Required for dbus support (optional)"
    TYPE OPTIONAL
)

find_package(X11)
if(X11_FOUND)
    find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED
        COMPONENTS
            X11Extras
    )
    set(HAVE_X11 TRUE)
    add_definitions(-DHAVE_X11)
else()
    set(HAVE_X11 FALSE)
endif()

# use sane compile flags
add_definitions(
-DQT_USE_QSTRINGBUILDER
-DQT_STRICT_ITERATORS
-DQT_NO_SIGNALS_SLOTS_KEYWORDS
-DQT_NO_URL_CAST_FROM_STRING
-DQT_NO_CAST_TO_ASCII
)

# only with this definition will all the FOO_TEST_EXPORT macro do something
# TODO: check if this can be moved to only those places which make use of it,
# to reduce global compiler definitions that would trigger a recompile of
# everything on a change (like adding/removing tests to/from the build)
if(BUILD_TESTING)
    add_definitions(-DCOMPILING_TESTS)
endif()

# overcome some platform incompatibilities
if(WIN32)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/winquirks)
    add_definitions(-D_USE_MATH_DEFINES)
    add_definitions(-DNOMINMAX)
    set(WIN32_PLATFORM_NET_LIBS ws2_32.lib netapi32.lib)
endif()

###########################
############################
## Required dependencies  ##
############################
###########################

##
## Test for KGantt
##
macro_optional_find_package(KGantt 2.6.0 QUIET)
set_package_properties(KGantt PROPERTIES
    DESCRIPTION "Library for creating Gantt diagrams (part of KDiagram)"
    URL "https://www.kde.org/"
    TYPE REQUIRED
)
if(KGantt_FOUND)
    set(KGANTT_VERSION_MAJOR "${KGantt_VERSION_MAJOR}")
    set(KGANTT_VERSION_MINOR "${KGantt_VERSION_MINOR}")
    set(KGANTT_VERSION_PATCH "${KGantt_VERSION_PATCH}")
endif()

##
## Test for KChart
##
macro_optional_find_package(KChart 2.6.0 QUIET)
set_package_properties(KChart PROPERTIES
    DESCRIPTION "Library for creating business charts (part of KDiagram)"
    URL "https://www.kde.org/"
    TYPE REQUIRED
)

##
## Test for QCA2
##
macro_optional_find_package(Qca-qt5 2.1.0 QUIET)
set_package_properties(Qca-qt5 PROPERTIES
    DESCRIPTION "Qt Cryptographic Architecture"
    URL "https:/download.kde.org/stable/qca-qt5"
    PURPOSE "Required for encrypted OpenDocument files and encrypted xls files support"
    TYPE OPTIONAL
)

find_package(KF5Wallet ${REQUIRED_KF5_VERSION})

if(Qca-qt5_FOUND AND KF5Wallet_FOUND)
    add_definitions( -DQCA2 )
endif()

find_package(Perl REQUIRED)

###########################
############################
## Optional dependencies  ##
############################
###########################

### Remove dependency on KF5AkonadiContact
### Review how to get at contacts in more portable way
##
## Test for KF5AkonadiContact
##
# find_package(KF5AkonadiContact CONFIG QUIET)
# set_package_properties(KF5AkonadiContact PROPERTIES
#     DESCRIPTION "Library for Accessing Contacts stored in Akonadi"
#     URL "https://www.kde.org/"
#     PURPOSE "Required for address book support"
#     TYPE OPTIONAL
# )

##
## Test for KF5CalendarCore
##
# find_package(KF5CalendarCore CONFIG QUIET)
# set_package_properties(KF5CalendarCore PROPERTIES
#     DESCRIPTION "KDE Calendar Library"
#     URL "https://www.kde.org/"
#     PURPOSE "Optionally used by semantic item Event"
#     TYPE OPTIONAL
#     )

if(WIN32)
    set(LIB_INSTALL_DIR ${LIB_INSTALL_DIR}
                        RUNTIME DESTINATION ${BIN_INSTALL_DIR}
                        LIBRARY ${INSTALL_TARGETS_DEFAULT_ARGS}
                        ARCHIVE ${INSTALL_TARGETS_DEFAULT_ARGS} )
endif()

#### Disable kreport for now, reconsider when it is stable ####
if (TEST_FOR_KREPORT)
    #
    # Test for KReport
    #
    macro_optional_find_package(KReport 3.1 QUIET)
    set_package_properties(KReport PROPERTIES
        PURPOSE "Required for KReport support in Plan"
        TYPE OPTIONAL
    )

    ##
    ## Test for KPropertyWidgets
    ##
    macro_optional_find_package(KPropertyWidgets 3.1 QUIET)
    set_package_properties(KPropertyWidgets PROPERTIES
        PURPOSE "Required for KReports support in Plan"
        TYPE OPTIONAL
    )
    if (KReport_FOUND AND KPropertyWidgets_FOUND)
        set(PLAN_USE_KREPORT TRUE)
    endif()
endif (TEST_FOR_KREPORT)


add_subdirectory(src)

add_subdirectory(devtools)

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

#add_custom_target(apidox doc/api/gendocs.pl WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

### Summarize findings ####
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)



find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== devtools/CMakeLists.txt ===


add_subdirectory(rng2cpp)

=== src/CMakeLists.txt ===

set(PLAN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/interfaces)

set(PLANPLUGIN_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/plugin
)

set(PLANKUNDO2_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/kundo2
    ${CMAKE_CURRENT_BINARY_DIR}/libs/kundo2
)

set(PLANSTORE_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/store
    ${CMAKE_CURRENT_BINARY_DIR}/libs/store
)

set(PLANODF_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/odf
    ${CMAKE_CURRENT_BINARY_DIR}/libs/odf
    ${PLANSTORE_INCLUDES}
)

set(PLANWIDGETS_INCLUDES 
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/widgetutils
    ${CMAKE_CURRENT_BINARY_DIR}/libs/widgetutils
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/widgets
    ${CMAKE_CURRENT_BINARY_DIR}/libs/widgets
)

set(PLANMAIN_INCLUDES 
    ${PLANWIDGETS_INCLUDES}
    ${PLANODF_INCLUDES}
    ${PLANKUNDO2_INCLUDES}
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/main
    ${CMAKE_CURRENT_BINARY_DIR}/libs/main
)

set(PLANKERNEL_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/kernel
    ${CMAKE_CURRENT_BINARY_DIR}/libs/kernel
)    

set(PLANMODELS_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/models
    ${CMAKE_CURRENT_BINARY_DIR}/libs/models
)    

set(PLANUI_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/ui
    ${CMAKE_CURRENT_BINARY_DIR}/libs/ui
)    

set(PLAN_INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR}

    ${PLANKERNEL_INCLUDES}
    ${PLANMODELS_INCLUDES}
    ${PLANUI_INCLUDES}
    ${PLANMAIN_INCLUDES}
)

# For odf
set(RNG_SOURCE_DIR ${PROJECT_SOURCE_DIR}/devtools/scripts)

if(KF5Holidays_FOUND)
    add_definitions(-DHAVE_KHOLIDAYS)
endif()

if (KF5AkonadiContact_FOUND)
    # disable for now: there is a bug
    # it only works if you use kde contacts (of course) but many use other stuff, so gets dissapointed
    add_definitions(-DPLAN_KDEPIMLIBS_FOUND)
    message(WARNING "AkonadiContacs available, but function is disabled due to Bug 311940")
endif ()

if (PLANCHARTDEBUG)
    add_definitions(-DPLAN_CHART_DEBUG)
endif ()

#add_subdirectory(interfaces)
add_subdirectory(servicetypes)

add_subdirectory( templates )
add_subdirectory( pics )
add_subdirectory( toolbar )
add_subdirectory( plugins )

add_subdirectory( libs )

if(BUILD_TESTING)
    add_subdirectory( tests )
endif()

add_subdirectory( workpackage )

include_directories(${PLAN_INCLUDES})

add_definitions(-DTRANSLATION_DOMAIN=\"calligraplan\")

########### KPlato private library ###############

set(planprivate_LIB_SRCS
    welcome/WelcomeView.cpp

    kptviewlistdocker.cpp
    kptviewlist.cpp
    kptviewlistdialog.cpp

    kptschedulesdocker.cpp

    kptconfig.cpp

    config/ConfigWorkVacationPanel.cpp
    config/ConfigProjectPanel.cpp
    config/kpttaskdefaultpanel.cpp
    config/kptworkpackageconfigpanel.cpp
    config/kptcolorsconfigpanel.cpp
    config/ConfigDocumentationPanel.cpp
    config/ConfigTaskModulesPanel.cpp
    config/ConfigProjectTemplatesPanel.cpp
    config/ConfigDialog.cpp

    kptcontext.cpp

    kptfactory.cpp
    kptpart.cpp
    kptmaindocument.cpp
    kptview.cpp
#     KPtViewAdaptor.cpp
    kptprintingcontrolprivate.cpp

    kptschedulerpluginloader.cpp
    kptbuiltinschedulerplugin.cpp
    kptconfigskeleton.cpp

    kptinsertfiledlg.cpp
    kptloadsharedprojectsdialog.cpp

    about/aboutpage.cpp

    KPlatoXmlLoader.cpp
)

ki18n_wrap_ui(planprivate_LIB_SRCS
    welcome/WelcomeView.ui

    kptviewlistaddview.ui
    kptviewlisteditview.ui
    kptviewlisteditcategory.ui

    config/ConfigWorkVacationPanel.ui
    config/ConfigProjectPanel.ui
    config/kptconfigtaskpanelbase.ui
    config/kptworkpackageconfigpanel.ui
    config/kptcolorsconfigpanel.ui
    config/ConfigDocumentationPanel.ui
    config/ConfigTaskModulesPanel.ui
    config/ConfigProjectTemplatesPanel.ui

    kptinsertfilepanel.ui
)

kconfig_add_kcfg_files(plansettings_SRCS calligraplansettings.kcfgc)

add_library(planprivate SHARED ${planprivate_LIB_SRCS} ${plansettings_SRCS} )
generate_export_header(planprivate BASE_NAME plan)

target_link_libraries(planprivate
    PUBLIC
        plankernel
        planmodels
        planui
        planmain
    PRIVATE
        planplugin
        KF5::IconThemes
        #KF5::KHtml
)
if(KF5AkonadiContact_FOUND)
    target_link_libraries(planprivate  PRIVATE KF5::AkonadiContact)
endif()
set_target_properties(planprivate PROPERTIES VERSION ${GENERIC_PLAN_LIB_VERSION} SOVERSION ${GENERIC_PLAN_LIB_SOVERSION} )

install(TARGETS planprivate ${INSTALL_TARGETS_DEFAULT_ARGS})

########### KPlato part ###############

set(planpart_PART_SRCS kptfactoryinit.cpp )

add_library(calligraplanpart MODULE ${planpart_PART_SRCS})

#calligraplan_part_desktop_to_json(calligraplanpart planpart.desktop)
if(${KF5_VERSION} VERSION_LESS "5.16.0")
    kcoreaddons_desktop_to_json(calligraplanpart planpart.desktop)
else()
    kcoreaddons_desktop_to_json(calligraplanpart planpart.desktop
#         SERVICE_TYPES ${PLAN_SOURCE_DIR}/servicetypes/calligraplan_part.desktop
    )
endif()


target_link_libraries(calligraplanpart PUBLIC KF5::Parts KF5::CoreAddons PRIVATE planprivate)

install(TARGETS calligraplanpart DESTINATION ${PLUGIN_INSTALL_DIR}/calligraplan/parts)


########### KPlato executable ###############

set(calligraplan_KDEINIT_SRCS main.cpp )

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/*-apps-calligraplan.png")
ecm_add_app_icon(kdeinit_app_ICONS_SRCS ICONS ${ICONS_SRCS})
if(WIN32)
    set(_resourcefile "${CMAKE_CURRENT_BINARY_DIR}/kdeinit_app_ICONS_SRCS.rc")
endif()

kf5_add_kdeinit_executable( calligraplan ${calligraplan_KDEINIT_SRCS})

if (APPLE)
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.template)
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.calligra.plan")
   set_target_properties(calligraplan PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "Plan")
   install( FILES ${CMAKE_CURRENT_BINARY_DIR}/calligraplan_KDEINIT_SRCS.icns DESTINATION ${BUNDLE_INSTALL_DIR}/calligraplan.app/Contents/Resources)
endif ()

target_link_libraries(kdeinit_calligraplan planmain)

install(TARGETS kdeinit_calligraplan  ${INSTALL_TARGETS_DEFAULT_ARGS})

target_link_libraries(calligraplan kdeinit_calligraplan planmain)
install(TARGETS calligraplan  ${INSTALL_TARGETS_DEFAULT_ARGS})

########### install files ###############

install( FILES  calligraplan.rc calligraplan_readonly.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/calligraplan)
install( PROGRAMS  org.kde.calligraplan.desktop  DESTINATION ${XDG_APPS_INSTALL_DIR})
install( FILES  calligraplanrc DESTINATION ${CONFIG_INSTALL_DIR})
install(FILES calligraplansettings.kcfg DESTINATION ${KCFG_INSTALL_DIR})
install(FILES org.kde.calligraplan.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# TODO: with the new embedded JSON data for plugins there is no schema ATM to define extended properties
# plan_viewplugin.desktop

install(FILES
    about/top-left-plan.png
    about/main.html
    about/intro.html
    about/tips.html
    about/tutorial.html
    about/plan.css
    DESTINATION ${DATA_INSTALL_DIR}/calligraplan/about
)

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h )

#add_custom_target(apidox doc/api/gendocs.pl WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

## Some tests do not work on freeBSD, so disable these tests until we found out why
STRING (REGEX MATCH "BSD" OS_BSD ${CMAKE_SYSTEM_NAME})
if (OS_BSD)
    message (WARNING "OS is ${CMAKE_SYSTEM_NAME}. Some i18n tests are disabled.")
endif()

###### Add i18n unit tests #############

find_program(BASH_PROGRAM bash)
find_program(XGETTEXT_PROGRAM xgettext)
find_program(MSGCAT_PROGRAM msgcat)

if (BASH_PROGRAM AND XGETTEXT_PROGRAM AND MSGCAT_PROGRAM)
    macro(PLAN_ADD_TEST_COMMAND _TEST_NAME)
        add_test("plan-${_TEST_NAME}" ${BASH_PROGRAM} "${CMAKE_CURRENT_SOURCE_DIR}/${_TEST_NAME}.sh"
                                "${PROJECT_SOURCE_DIR}/kundo2_aware_xgettext.sh"
                                "${XGETTEXT_PROGRAM}"
                                "${MSGCAT_PROGRAM}"
                                "${CMAKE_CURRENT_BINARY_DIR}/po"
        )
    endmacro()
    macro(PLAN_ADD_UNIT_TEST _TEST_NAME)
        add_custom_target(Plan${_TEST_NAME} ALL
            COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/${_TEST_NAME}.cpp" "${CMAKE_CURRENT_BINARY_DIR}/${_TEST_NAME}.cpp"
            COMMENT "Copy test files" VERBATIM
        )
        PLAN_ADD_TEST_COMMAND(${_TEST_NAME})
    endmacro()

    # create the podir
    add_custom_target(Planpodir ALL
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/po
        COMMENT "Create podir" VERBATIM)
    # copy parameters script
    add_custom_target(Planparameters ALL
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/parameters.sh ${CMAKE_CURRENT_BINARY_DIR}/parameters.sh
        COMMENT "Copy parameters script" VERBATIM)

    # add tests here
    if (NOT OS_BSD)
        PLAN_ADD_UNIT_TEST(test_i18n)
        PLAN_ADD_UNIT_TEST(test_i18nc)
        PLAN_ADD_UNIT_TEST(test_i18nc_long)
    endif()

    PLAN_ADD_UNIT_TEST(test_i18np)
    PLAN_ADD_UNIT_TEST(test_i18n_noop)
    PLAN_ADD_UNIT_TEST(test_i18n_noop2)

    PLAN_ADD_UNIT_TEST(test_xi18n)
    PLAN_ADD_UNIT_TEST(test_xi18nc)
    PLAN_ADD_UNIT_TEST(test_xi18nc_long)
    PLAN_ADD_UNIT_TEST(test_xi18np)
    PLAN_ADD_UNIT_TEST(test_xi18ncp)

    PLAN_ADD_UNIT_TEST(test_kundo2_i18n)
    PLAN_ADD_UNIT_TEST(test_kundo2_i18nc)
    PLAN_ADD_UNIT_TEST(test_kundo2_i18nc_long)

    # this uses cpp files from earlier tests
    if (NOT OS_BSD)
        PLAN_ADD_TEST_COMMAND(test_i18n_mixed)
    endif()

    # add test of Messages.sh
    add_test(test_Messages ${BASH_PROGRAM} "${CMAKE_CURRENT_SOURCE_DIR}/test_messages.sh" "${PROJECT_SOURCE_DIR}")
endif()

=== src/toolbar/CMakeLists.txt ===
ecm_install_icons( ICONS
    22-actions-view-task-child-add.png
    22-actions-view-time-schedule-insert.png

    DESTINATION ${DATA_INSTALL_DIR}/calligraplan/icons
    THEME hicolor
)

=== src/libs/kundo2/CMakeLists.txt ===
include_directories(${PLANKUNDO2_INCLUDES})

set(kundo2_LIB_SRCS
	kundo2stack.cpp
	kundo2group.cpp
	kundo2view.cpp
	kundo2model.cpp
	kundo2magicstring.cpp
	kundo2commandextradata.cpp
)

add_library(plankundo2 SHARED ${kundo2_LIB_SRCS})
generate_export_header(plankundo2 BASE_NAME kundo2)

target_link_libraries(plankundo2
    PUBLIC
        KF5::I18n
        KF5::XmlGui
        Qt5::Core
        Qt5::Widgets
    PRIVATE
        KF5::ConfigWidgets
)

set_target_properties(plankundo2 PROPERTIES
    VERSION ${GENERIC_PLAN_LIB_VERSION} SOVERSION ${GENERIC_PLAN_LIB_SOVERSION}
)
install(TARGETS plankundo2 ${INSTALL_TARGETS_DEFAULT_ARGS})

=== src/libs/ui/CMakeLists.txt ===


include_directories(
    ${PLANKERNEL_INCLUDES}
    ${PLANMODELS_INCLUDES}
    ${PLANMAIN_INCLUDES}
    ${PLANWIDGETS_INCLUDES}
    ${KDEPIMLIBS_INCLUDE_DIR}
)

#add_subdirectory( tests )

########### KPlato private library ###############

if (PLAN_USE_KREPORT)
    message(STATUS "-- Building plan with reports capability")
    add_subdirectory(reports/items)

    set(planreports_LIB_SRC
        reports/reportview.cpp
        reports/reportdata.cpp
        reports/reportsourceeditor.cpp
        reports/reportscripts.cpp
    )
    set(planreports_ui_LIB_SRCS
        reports/reportsourceeditor.ui
        reports/reportnavigator.ui
        reports/reportsectionswidget.ui
        reports/reportgroupsectionswidget.ui
        reports/reporttoolswidget.ui
    )

endif()

set(planui_LIB_SRCS
    ${planreports_LIB_SRC}

    RelationEditorDialog.cpp
    TasksEditController.cpp
    TasksEditDialog.cpp

    RichTextWidget.cpp

    reportsgenerator/ReportsGeneratorView.cpp

    kptganttitemdelegate.cpp

    kptworkpackagesendpanel.cpp
    kptworkpackagesenddialog.cpp
    kptdocumentseditor.cpp
    kptdocumentspanel.cpp
    kptdocumentsdialog.cpp
    
    kptitemviewsettup.cpp
    kptsplitterview.cpp
    kptrelationeditor.cpp
    kptdependencyeditor.cpp
    kptusedefforteditor.cpp
    kpttaskstatusview.cpp
    kptcalendareditor.cpp
    kptviewbase.cpp
    kptaccountseditor.cpp
    kptperteditor.cpp
    kptpertresult.cpp
    kpttaskeditor.cpp
    kptresourceeditor.cpp
    kptscheduleeditor.cpp
    kptsummarytaskdialog.cpp
    kptsummarytaskgeneralpanel.cpp
    kptresourceappointmentsview.cpp
    kptaccountsviewconfigdialog.cpp
    kptaccountsview.cpp
    kpttaskcostpanel.cpp
    kptmilestoneprogresspanel.cpp
    kptmilestoneprogressdialog.cpp
    kpttaskdialog.cpp
    kptmainprojectdialog.cpp
    kptmainprojectpanel.cpp
    kptganttview.cpp
    gantt/DateTimeTimeLine.cpp
    gantt/DateTimeGrid.cpp
    kptrelationdialog.cpp
    kptrequestresourcespanel.cpp
    kptresourcedialog.cpp
    kptstandardworktimedialog.cpp
    kptintervaledit.cpp
    kpttaskgeneralpanel.cpp
    kpttaskprogresspanel.cpp
    kpttaskprogressdialog.cpp
    kpttaskdescriptiondialog.cpp
    kptwbsdefinitiondialog.cpp
    kptwbsdefinitionpanel.cpp
    kptresourceassignmentview.cpp
    kptresourceallocationeditor.cpp
    kptworkpackagemergedialog.cpp
    kptrecalculatedialog.cpp

    kpthtmlview.cpp

    locale/localemon.cpp
    kptlocaleconfigmoneydialog.cpp

    ResourceAllocationView.cpp

    performance/KPlatoChart.cpp
    performance/PerformanceStatusBase.cpp
    performance/ProjectStatusView.cpp
    performance/PerformanceStatusView.cpp
    performance/PerformanceTableView.cpp
)

ki18n_wrap_ui(planui_LIB_SRCS
    ${planreports_ui_LIB_SRCS}

    RelationEditorDialog.ui

    kptresourceappointmentsdisplayoptions.ui
    kptganttchartdisplayoptions.ui

    kptprintingheaderfooter.ui
    kptganttprintingoptions.ui

    kptworkpackagesendpanel.ui
    
    kptdocumentspanel.ui
    
    performance/PerformanceStatus.ui
    performance/PerformanceStatusViewSettingsPanel.ui
    
    kptcpmwidget.ui
    kptitemviewsettings.ui
    kptpertresult.ui
    standardworktimedialogbase.ui
    kptwbsdefinitionpanelbase.ui
    kptaccountsviewconfigurepanelbase.ui
    kptintervaleditbase.ui
    kpttaskcostpanelbase.ui
    kpttaskdescriptionpanelbase.ui
    kptsummarytaskgeneralpanelbase.ui
    kptmilestoneprogresspanelbase.ui
    resourcedialogbase.ui
    kptmainprojectpanelbase.ui
    relationpanel.ui
    kpttaskgeneralpanelbase.ui
    kpttaskprogresspanelbase.ui
    kptperteditor.ui
    kptresourceassignmentview.ui
    kpttaskstatusviewsettingspanel.ui
    kptworkpackagemergepanel.ui
    kptrecalculatedialog.ui
    kptscheduleeditor.ui

    locale/localemon.ui
)

add_library(planui SHARED ${planui_LIB_SRCS})
generate_export_header(planui)

target_link_libraries(planui
    PUBLIC
        planmain
        planmodels
        KF5::KHtml
    PRIVATE
        KChart
        KF5::ItemViews
        KF5::IconThemes
        KF5::Archive
        KF5::TextWidgets
        KF5::KIOCore
        KF5::KIOFileWidgets
        KF5::KIOWidgets
        KF5::KIONTLM
)
if (PLAN_USE_KREPORT)
    target_link_libraries(planui PUBLIC KReport PRIVATE KPropertyWidgets)
endif()

if(KF5AkonadiContact_FOUND)
    target_link_libraries(planui  PRIVATE KF5::AkonadiContact)
endif()

set_target_properties(planui PROPERTIES VERSION ${GENERIC_PLAN_LIB_VERSION} SOVERSION ${GENERIC_PLAN_LIB_SOVERSION} )

install(TARGETS planui ${INSTALL_TARGETS_DEFAULT_ARGS})

install( FILES
        AccountsEditorUi.rc
        AccountsEditorUi_readonly.rc
        AccountsViewUi.rc
        CalendarEditorUi.rc
        CalendarEditorUi_readonly.rc
        TaskEditorUi.rc
        TaskEditorUi_readonly.rc
        DependencyEditorUi.rc
        DependencyEditorUi_readonly.rc
        ResourceEditorUi.rc
        ResourceEditorUi_readonly.rc
        ResourceAppointmentsViewUi.rc
        ScheduleEditorUi.rc
        ScheduleEditorUi_readonly.rc
        GanttViewUi.rc
        WorkPackageViewUi.rc
        WorkPackageViewUi_readonly.rc
        reportsgenerator/ReportsGeneratorViewUi.rc
        reportsgenerator/ReportsGeneratorViewUi_readonly.rc
        performance/PerformanceStatusViewUi.rc
        performance/ProjectStatusViewUi.rc
        PertResultUi.rc
        TaskViewUi.rc
        TaskStatusViewUi.rc
    DESTINATION ${KXMLGUI_INSTALL_DIR}/calligraplan
)

# reports files
install(FILES
        reportsgenerator/templates/EmptyTemplate.odt
        reportsgenerator/templates/ProjectPerformanceCost.odt
        reportsgenerator/templates/ProjectPerformanceEffort.odt
        reportsgenerator/templates/TaskStatus.odt
    DESTINATION ${DATA_INSTALL_DIR}/calligraplan/reports
)

=== src/libs/widgetutils/CMakeLists.txt ===

set(kowidgetutils_LIB_SRCS
    Help.cpp
    KoProgressBar.cpp
    KoProgressUpdater.cpp
    KoUpdater.cpp
    KoUpdaterPrivate_p.cpp
    KoFileDialog.cpp
)


add_library(planwidgetutils SHARED ${kowidgetutils_LIB_SRCS})
generate_export_header(planwidgetutils BASE_NAME kowidgetutils)

target_link_libraries(planwidgetutils
    PUBLIC
        Qt5::Widgets
        Qt5::Gui
        Qt5::Xml
        Qt5::Core
    PRIVATE
        KF5::I18n
        KF5::ConfigCore
        KF5::ConfigWidgets
)

set_target_properties(planwidgetutils
    PROPERTIES VERSION ${GENERIC_PLAN_LIB_VERSION} SOVERSION ${GENERIC_PLAN_LIB_SOVERSION}
)

install(TARGETS planwidgetutils ${INSTALL_TARGETS_DEFAULT_ARGS})

=== src/libs/odf/tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${PLANODF_INCLUDES} )

# call: planodf_add_unit_test(<test-name> <sources> LINK_LIBRARIES <library> [<library> [...]] [GUI])
macro(PLANODF_ADD_UNIT_TEST _TEST_NAME)
    ecm_add_test( ${ARGN}
        TEST_NAME "Plan${_TEST_NAME}"
        NAME_PREFIX "plan-odf-"
    )
endmacro()

########### next target ###############

planodf_add_unit_test(TestKoGenStyles TestKoGenStyles.cpp  LINK_LIBRARIES planodf KF5::I18n Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestOdfSettings TestOdfSettings.cpp  LINK_LIBRARIES planodf KF5::I18n Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestKoOdfLoadingContext TestKoOdfLoadingContext.cpp  LINK_LIBRARIES planodf KF5::I18n Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestXmlWriter TestXmlWriter.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestXmlReader TestXmlReader.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestXmlReaderWithoutSpaces TestXmlReaderWithoutSpaces.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(kodomtest kodomtest.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestStorage TestStorage.cpp  LINK_LIBRARIES planodf KF5::I18n Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestKoUnit TestKoUnit.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

## Disable ftb. spurioulsy fails
# planodf_add_unit_test(TestNumberStyle TestNumberStyle.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestKoElementReference TestKoElementReference.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### next target ###############

planodf_add_unit_test(TestWriteStyleXml TestWriteStyleXml.cpp  LINK_LIBRARIES planodf Qt5::Test)

########### end ###############

=== src/plugins/scripting/scripts/CMakeLists.txt ===
install(FILES scripts.rc DESTINATION ${DATA_INSTALL_DIR}/calligraplan/scripts)

install(FILES
    resourcesimport.py
    busyinfoexport.py
    busyinfoimport.py
    busyinfoclear.py
    plan2csvexport.py
    plan2odsexport.py
    DESTINATION ${DATA_INSTALL_DIR}/calligraplan/scripts/extensions)

install(FILES
    sample_project.py
    sample_busyinfocheck.py
    DESTINATION ${DATA_INSTALL_DIR}/calligraplan/scripts/samples)

=== src/plugins/scripting/tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( .. ${PLAN_INCLUDES} ${KOKROSS_INCLUDES} ${KOSTORE_INCLUDES})

add_definitions(-DFILES_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

########### next target ###############

set (ScriptingTester_SRCS ScriptingTester.cpp TestResult.cpp)

ecm_add_test(
    ${ScriptingTester_SRCS}
    TEST_NAME ScriptingTester
    NAME_PREFIX "plan-"
    LINK_LIBRARIES
        krossmoduleplan
        planprivate
        plankernel
        plankross
        Qt5::Test
)

=== src/workpackage/templates/Simple/CMakeLists.txt ===
install( FILES  Empty.planworkt  DESTINATION ${DATA_INSTALL_DIR}/calligraplanwork/templates/Simple/.source)
install( FILES  .directory Empty.desktop DESTINATION ${DATA_INSTALL_DIR}/calligraplanwork/templates/Simple)

ecm_install_icons( ICONS
    16-actions-template_empty.png
    22-actions-template_empty.png
    32-actions-template_empty.png
    48-actions-template_empty.png
    64-actions-template_empty.png
    128-actions-template_empty.png

    DESTINATION ${DATA_INSTALL_DIR}/calligraplanwork/icons
    THEME hicolor
)

=== debian/changelog ===
calligraplan (1:3.2.2-2) unstable; urgency=medium

  * Backport upstream commit f77fb06dc5d9f7930da9c757d6916f1149dc42bd to fix
    build with Qt 5.15; patch upstream_Fix-build-with-Qt-5.15.patch.
    (Closes: #975141)
  * Update renamed lintian tag names in lintian overrides.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Switch the watch file to version 4, no changes required.
  * Add Rules-Requires-Root: no.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Remove the explicit as-needed linking, as it is done by binutils now.

 -- Pino Toscano <pino@debian.org>  Sun, 22 Nov 2020 14:26:18 +0100

calligraplan (1:3.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 12 Dec 2019 21:17:42 +0100

=== debian/control ===
Source: calligraplan
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.19.0),
               gettext,
               kinit-dev (>= 5.45.0~),
               libkchart-dev,
               libkf5activities-dev (>= 5.45.0~),
               libkf5archive-dev (>= 5.45.0~),
               libkf5config-dev (>= 5.45.0~),
               libkf5configwidgets-dev (>= 5.45.0~),
               libkf5coreaddons-dev (>= 5.45.0~),
               libkf5dbusaddons-dev (>= 5.45.0~),
               libkf5guiaddons-dev (>= 5.45.0~),
               libkf5holidays-dev,
               libkf5i18n-dev (>= 5.45.0~),
               libkf5iconthemes-dev (>= 5.45.0~),
               libkf5itemviews-dev (>= 5.45.0~),
               libkf5jobwidgets-dev (>= 5.45.0~),
               libkf5khtml-dev (>= 5.45.0~),
               libkf5kio-dev (>= 5.45.0~),
               libkf5notifications-dev (>= 5.45.0~),
               libkf5parts-dev (>= 5.45.0~),
               libkf5textwidgets-dev (>= 5.45.0~),
               libkf5wallet-dev (>= 5.45.0~),
               libkf5widgetsaddons-dev (>= 5.45.0~),
               libkf5windowsystem-dev (>= 5.45.0~),
               libkf5xmlgui-dev (>= 5.45.0~),
               libkgantt-dev,
               libqca-qt5-2-dev,
               libqt5opengl5-dev (>= 5.9.0~),
               libqt5x11extras5-dev (>= 5.9.0~),
               libx11-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.9.0~),
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.calligra.org/plan/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/calligraplan.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/calligraplan

Package: calligraplan
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: ${plan:oldLangs}
Replaces: ${plan:oldLangs}
Description: integrated project management and planning tool
 Plan is a project management application, allowing for the planning and
 scheduling of projects. It was formerly known as KPlato.
 .
 This package is part of the Calligra Suite.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# conflicts with old calligra-l10n
# (mostly copied from l10n-packages.mk in pkg-kde-tools)
l10npkgs_firstversion_ok := 1:3.1.0~
l10npkgs_prefix := calligra-l10n
l10npkgs_fixed_version_comma := (<< $(l10npkgs_firstversion_ok)),
# the list of languages in calligra < 3.1
l10npkgs_langs := bs ca cavalencia cs da de el engb es et eu fi fr gl hu it ja kk nb nds nl pl pt ptbr ru sk sv tr uk zhcn zhtw
l10npkgs_packages_rels := $(patsubst %,$(l10npkgs_prefix)-% $(l10npkgs_fixed_version_comma),$(l10npkgs_langs))

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove symlinks of private libraries
	find debian/calligraplan -name '*.so' -type l -print -delete

override_dh_gencontrol:
	dh_gencontrol -- -Vplan:oldLangs='$(l10npkgs_packages_rels)'

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
https://download.kde.org/stable/calligra/([\d\.]+)/calligraplan-([\d\.]+)\.tar\.xz
